SystemOrganization addCategory: #RefactoringTools!

RBClassRefactoring subclass: #RBGenerateEqualHashRefactoring
	instanceVariableNames: 'selectors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RefactoringTools'!

!RBGenerateEqualHashRefactoring commentStamp: 'rms 4/8/2015 22:46' prior: 0!
A RBGenerateEqualHashRefactoring is essentially a copy of OmniBrowsers custom Equal Hash refactoring.

Instance Variables
	selectors:		<Object>

selectors
	- xxxxx
!

!RBGenerateEqualHashRefactoring class methodsFor: 'as yet unclassified' stamp: 'rms 4/8/2015 22:47'!
className: aClass selectors: anArray
	^ (super className: aClass) selectors: anArray! !

!RBGenerateEqualHashRefactoring class methodsFor: 'as yet unclassified' stamp: 'rms 4/12/2015 18:44'!
model: aRBModel className: aClass selectors: anArray
	^ (super className: aClass) 
		selectors: anArray;
		model: aRBModel;
		yourself! !

!RBGenerateEqualHashRefactoring methodsFor: 'as yet unclassified' stamp: 'rms 4/8/2015 22:45'!
accessor: aSelector for: aVariableString
	^ RBMessageNode receiver: (RBVariableNode named: aVariableString) selector: aSelector! !

!RBGenerateEqualHashRefactoring methodsFor: 'as yet unclassified' stamp: 'rms 4/8/2015 22:45'!
compileEqual
	| method statement comparison |
	method := RBParser parseMethod: '= anObject
		"Answer whether the receiver and anObject represent the same object."

		self == anObject ifTrue: [ ^ true ].
		self class = anObject class ifFalse: [ ^ false ]'.
	statement := nil.	
	selectors reverse do: [ :each |
		comparison := RBMessageNode 
			receiver: (self accessor: each for: 'self') 
			selector: #=
			arguments: (Array with: (self accessor: each for: 'anObject')).
		statement isNil
			ifTrue: [ statement := comparison ]
			ifFalse: [
				statement := RBMessageNode
					receiver: comparison
					selector: #and:
					arguments: (Array with: (RBBlockNode 
						body: (RBSequenceNode 
							statements: (Array with: statement)))) ] ].
	method addNode: statement; addReturn.
	self theClass 
		compile: method formattedCode
		classified: #(comparing)! !

!RBGenerateEqualHashRefactoring methodsFor: 'as yet unclassified' stamp: 'rms 4/8/2015 22:45'!
compileHash
	| method statement hash |
	method := RBParser parseMethod: 'hash
		"Answer an integer value that is related to the identity of the receiver."'.
	statement := nil.	
	selectors reverse do: [ :each |
		hash := RBMessageNode 
			receiver: (self accessor: each for: 'self')
			selector: #hash.
		statement isNil
			ifTrue: [ statement := hash ]
			ifFalse: [
				statement := RBMessageNode
					receiver: hash
					selector: #bitXor:
					arguments: (Array with: statement) ] ].
	method addNode: statement; addReturn.
	self theClass
		compile: method formattedCode
		classified: #(comparing)! !

!RBGenerateEqualHashRefactoring methodsFor: 'as yet unclassified' stamp: 'rms 4/8/2015 22:46'!
preconditions
	^ selectors
		inject: (RBCondition 
			withBlock: [ selectors notEmpty and: [ selectors allSatisfy: [ :each | each numArgs = 0 ] ] ] 
			errorString: 'No valid accessor methods given')
		into: [ :condition :selector | condition & (RBCondition hierarchyOf: self theClass canUnderstand: selector) ]! !

!RBGenerateEqualHashRefactoring methodsFor: 'as yet unclassified' stamp: 'rms 4/8/2015 22:46'!
selectors: anArray
	selectors := anArray! !

!RBGenerateEqualHashRefactoring methodsFor: 'as yet unclassified' stamp: 'rms 4/8/2015 22:46'!
theClass
	^ (self classObjectFor: className) theNonMetaClass! !

!RBGenerateEqualHashRefactoring methodsFor: 'as yet unclassified' stamp: 'rms 4/8/2015 22:46'!
transform
	self compileHash.
	self compileEqual! !

RBClassRefactoring subclass: #RBGeneratePrintStringRefactoring
	instanceVariableNames: 'variables'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RefactoringTools'!

!RBGeneratePrintStringRefactoring class methodsFor: 'as yet unclassified' stamp: 'rms 4/9/2015 18:36'!
className: aClass variables: anArray
	^ (super className: aClass) variables: anArray! !

!RBGeneratePrintStringRefactoring class methodsFor: 'as yet unclassified' stamp: 'rms 4/12/2015 18:44'!
model: aRBModel className: aClass variables: anArray
	^ (super className: aClass) 
		variables: anArray;
		model: aRBModel
		yourself! !

!RBGeneratePrintStringRefactoring methodsFor: 'as yet unclassified' stamp: 'rms 4/9/2015 18:36'!
preconditions
	^ variables
		inject: RBCondition empty
		into: [ :condition :variable | condition & (RBCondition definesInstanceVariable: variable in: self theClass) ]! !

!RBGeneratePrintStringRefactoring methodsFor: 'as yet unclassified' stamp: 'rms 4/9/2015 18:36'!
theClass
	^ (self classObjectFor: className) theNonMetaClass! !

!RBGeneratePrintStringRefactoring methodsFor: 'as yet unclassified' stamp: 'rms 4/9/2015 18:36'!
transform
	| method |
	method := RBParser parseMethod: 'printOn: aStream
		"Append a sequence of characters to aStream that identify the receiver."
		
		super printOn: aStream'.
	variables do: [ :each |
		method body addNode: (RBParser 
			parseExpression: ('aStream nextPutAll: '' <1s>: ''; print: <1s>'
				expandMacrosWith: each)) ].
	self theClass
		compile: method formattedCode
		classified: #(printing)! !

!RBGeneratePrintStringRefactoring methodsFor: 'as yet unclassified' stamp: 'rms 4/9/2015 18:36'!
variables: anArray
	variables := anArray! !

RBClassRefactoring subclass: #RBRealizeClassRefactoring
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RefactoringTools'!

!RBRealizeClassRefactoring methodsFor: 'as yet unclassified' stamp: 'rms 4/9/2015 20:53'!
preconditions
	^ RBCondition
		withBlock: [
			(self theClass withAllSubclasses
				detect: [ :each | 
					(each whichSelectorsReferToSymbol: #subclassResponsibility) notEmpty 
						or: [ (each theMetaClass whichSelectorsReferToSymbol: #subclassResponsibility) notEmpty ] ]
				ifNone: [ nil ]) isNil ]
		errorString: self theClass printString , ' is abstract or has abstract subclasses.'! !

!RBRealizeClassRefactoring methodsFor: 'as yet unclassified' stamp: 'rms 4/9/2015 20:53'!
theClass
	^ (self classObjectFor: className) theNonMetaClass! !

!RBRealizeClassRefactoring methodsFor: 'as yet unclassified' stamp: 'rms 4/9/2015 20:54'!
transform
	self transform: self theClass.
	self transform: self theClass theMetaClass! !

!RBRealizeClassRefactoring methodsFor: 'as yet unclassified' stamp: 'rms 4/9/2015 20:54'!
transform: aClass
	| class method parseTree |
	aClass allSelectors do: [ :selector |
		class := aClass whoDefinesMethod: selector.
		(class notNil and: [ class ~= aClass ]) ifTrue: [
			method := class methodFor: selector.
			(method notNil and: [ method refersToSymbol: #subclassResponsibility ]) ifTrue: [
				parseTree := method parseTree.
				parseTree body 
					temporaries: OrderedCollection new; 
					statements: OrderedCollection new;
					addNode: (RBMessageNode 
						receiver: (RBVariableNode named: 'self')
						selector: #shouldBeImplemented).
				aClass compile: parseTree newSource withAttributesFrom: method ] ] ]! !

!CodeHolder methodsFor: '*RefactoringTools-source-refactoring' stamp: 'eem 3/13/2018 16:04'!
createCascadeRefactoring
	^RBCreateCascadeRefactoring
		model: self browserModel
		combine: self selectedInterval
		from: self selectedMessageName
		in: self selectedClassOrMetaClass! !

!CodeHolder methodsFor: '*RefactoringTools-source-refactoring' stamp: 'eem 3/13/2018 16:04'!
extractMethodRefactoring
	| extractRef |
	extractRef := (RBExtractMethodRefactoring
		model: self browserModel
		extract: self selectedInterval
		from: self selectedMessageName
		in: self selectedClassOrMetaClassName).
	extractRef setOption: #methodName
		toUse: 
			[:ref :methodName | 
			| extractedMethodSelector |
			extractedMethodSelector := ref uniqueMethodNameFor: methodName arguments size.
			self requestMethodNameFor: extractedMethodSelector].
	^extractRef! !

!CodeHolder methodsFor: '*RefactoringTools-source-refactoring' stamp: 'eem 3/13/2018 15:47'!
extractMethodToComponentRefactoring
	| refactoring classNames |						
	classNames := (SmalltalkImage current allClasses collect: [:class | class name]). 
	refactoring := RBExtractMethodToComponentRefactoring
		model: self browserModel
		extract: self selectedInterval
		from: self selectedMessageName
		in: self selectedClassOrMetaClass.
	refactoring options at: #extractAssignment
						put: [:ref :variableName | 
							  (self confirm: 'Extract assigment to temp variable "' ,  variableName , '" as well?') not ].
	refactoring options at: #methodName
						put: [:ref :methodName | self requestMethodNameFor: methodName].
	refactoring options at: #variableTypes
						put: [:ref :types :selected |
							Array with:
							  ((RBClass 
								existingNamed:
							      (UIManager default 
									chooseFrom: classNames
									values: classNames
									title: 'Enter class to extract method to (component):'))
								model: ref model)].
	refactoring options at: #selectVariableToMoveTo
						put: [ :ref :class :selector | 
							   self request: 'Enter var name to hold instance of component:'
								    initialAnswer: ''].
	^refactoring! !

!CodeHolder methodsFor: '*RefactoringTools-source-refactoring' stamp: 'eem 3/13/2018 15:47'!
extractToTemporaryRefactoring
	^RBExtractToTemporaryRefactoring
		model: self browserModel
		extract: self selectedInterval
		to: (self request: 'Enter name for temporary var:' initialAnswer: '')
		from: self selectedMessageName
		in: self selectedClassOrMetaClass ! !

!CodeHolder methodsFor: '*RefactoringTools-source-refactoring' stamp: 'eem 3/13/2018 15:47'!
inlineMethodFromComponentRefactoring
	| refactoring |
	refactoring := RBInlineMethodFromComponentRefactoring
		model: self browserModel
		inline: self selectedInterval
		inMethod: self selectedMessageName
		forClass: self selectedClassOrMetaClass.
	refactoring options at: #implementorToInline put: 
		[:ref :imps | UIManager default chooseFrom: imps values: imps title: 'Select Implementor:'].
	refactoring options at: #inlineExpression put: 
		[:ref :string | UIManager confirm: 'Inline the expression "', string , '" as well?'].
	^refactoring! !

!CodeHolder methodsFor: '*RefactoringTools-source-refactoring' stamp: 'eem 3/13/2018 15:48'!
inlineMethodRefactoring
	^RBInlineMethodRefactoring
		model: self browserModel
		inline: self selectedInterval
		inMethod: self selectedMessageName
		forClass: self selectedClassOrMetaClass! !

!CodeHolder methodsFor: '*RefactoringTools-source-refactoring' stamp: 'eem 3/13/2018 15:48'!
inlineTemporaryRefactoring
	^RBInlineTemporaryRefactoring 
		model: self browserModel
		inline: self selectedInterval
		from: self selectedMessageName
		in: self selectedClassOrMetaClass! !

!CodeHolder methodsFor: '*RefactoringTools-source-refactoring' stamp: 'eem 3/13/2018 15:48'!
moveVariableDefinitionRefactoring 
	^RBMoveVariableDefinitionRefactoring
		model: self browserModel
		bindTight: self selectedInterval
		in: self selectedClassOrMetaClass
		selector: self selectedMessageName! !

!CodeHolder methodsFor: '*RefactoringTools' stamp: 'rms 4/12/2015 20:41'!
performRefactoring: aSelector 
	| refactoring |
	[refactoring := self perform: aSelector.
	refactoring isCollection
		ifTrue: [refactoring
				do: [:ref | ref execute]]
		ifFalse: [refactoring execute]]
		on: RBRefactoringError
		do: [:error | UIManager default inform: error messageText]! !

!CodeHolder methodsFor: '*RefactoringTools-source-refactoring' stamp: 'eem 3/13/2018 15:48'!
renameTemporaryRefactoring
	^RBRenameTemporaryRefactoring
		model: self browserModel
		renameTemporaryFrom: self selectedInterval
		to: (self request: 'Enter new name:' initialAnswer: '')
		in: self selectedClassOrMetaClass
		selector: self selectedMessageName! !

!CodeHolder methodsFor: '*RefactoringTools' stamp: 'rms 4/14/2015 15:25'!
requestMethodNameFor: suggestedMethodName
	| string parser pattern |
	string := self 
		request: 'Method Name:'
		initialAnswer: suggestedMethodName asString.
	parser := RBParser new.
	parser errorBlock: [ :error :position | ^ nil ].
	parser initializeParserWith: string.
	pattern := parser parseMessagePattern.
	^ RBMethodName
		selector: pattern selector
		arguments: pattern argumentNames! !

!CodeHolder methodsFor: '*RefactoringTools-source-refactoring' stamp: 'eem 1/4/2018 16:38'!
sourceRefactoringMenu: aMenu
	<codePaneMenu>
	<menuPriority:  400>
	self sourceRefactoringsAreApplicable ifTrue:
		[aMenu addRefactorings: self sourceRefactorings withName: 'refactor source' for: self].
	^aMenu! !

!CodeHolder methodsFor: '*RefactoringTools-source-refactoring' stamp: 'rms 4/14/2015 15:21'!
sourceRefactorings
"TODO: Extract these method references to separate command objects, just like OB does.
 This enabled easy implementation of applicability checks, detailed information halos and nessecary state
  to perform the refactoring. "
	^{ 'extract method' 
			-> #extractMethodRefactoring 
			-> 'Extracts the selected code to a separate method.' .
	    'extract method to component' 
			-> #extractMethodToComponentRefactoring "Not yet working"
			-> 'Extracts the selected code as a separate method into a different class.' .
	    'extract to temporary' 
			-> #extractToTemporaryRefactoring 
			-> 'Extracts a message into an assignment statement.' .
	    'rename temporary' 
			-> #renameTemporaryRefactoring 
			-> 'Renames a temporary variable.' .
	    'inline method' 
			-> #inlineMethodRefactoring 
			-> 'Inlines a message send.'.
	    'inline temporary' 
			-> #inlineTemporaryRefactoring
			-> 'Removes the assignment of a variable and replaces all references to the variable with the right hand side of the assignment.' .
	    'inline method from component' 
			-> #inlineMethodFromComponentRefactoring
			-> 'Inlines a message send to a different object.' .
	    'create cascade' 
			-> #createCascadeRefactoring
			-> 'Create a cascade from a sequence of statements with the same receiver.' .
	    'split cascade' 
			-> #splitCascadeRefactoring
			-> 'Splits a cascade into two cascades. Splitting point is determined by the current position of the cursor.' .
	    'move variable definition' 
			-> #moveVariableDefinitionRefactoring
			-> 'Moves a temporary variable definition into the tightest scope that contains both the variable assignment and references.' .
	    'temporary to instvar' 
			-> #temporaryInstvarRefactoring
			-> 'Converts a temporary into an instance variable.' } as: Dictionary! !

!CodeHolder methodsFor: '*RefactoringTools-source-refactoring' stamp: 'eem 1/4/2018 16:50'!
sourceRefactoringsAreApplicable
	"Subclasses that want to include the source refactorings should reimplement
	 this appropriartely.  See e.g. Browser>>sourceRefactoringsAreApplicable"
	^false! !

!CodeHolder methodsFor: '*RefactoringTools-source-refactoring' stamp: 'eem 3/13/2018 15:48'!
splitCascadeRefactoring
	^RBSplitCascadeRefactoring
		model: self browserModel
		split: self selectedInterval
		from: self selectedMessageName
		in: self selectedClassOrMetaClass! !

!CodeHolder methodsFor: '*RefactoringTools-source-refactoring' stamp: 'eem 3/13/2018 15:41'!
temporaryInstvarRefactoring
	^RBTemporaryToInstanceVariableRefactoring
		model: self browserModel
		class: self selectedClassOrMetaClass
		selector: self selectedMessageName
		variable: (self contents 
			copyFrom: self selectedInterval start 
			to: self selectedInterval end)! !

RBMethodRefactoring subclass: #RBCreateCascadeRefactoring
	instanceVariableNames: 'selector selectedInterval parseTree sequenceNode statementNodes transformedNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RefactoringTools'!

!RBCreateCascadeRefactoring class methodsFor: 'as yet unclassified' stamp: 'rms 4/9/2015 21:06'!
combine: anInterval from: aSelector in: aClass
	^ self new 
		combine: anInterval from: aSelector in: aClass;
		yourself! !

!RBCreateCascadeRefactoring class methodsFor: 'as yet unclassified' stamp: 'rms 4/12/2015 18:09'!
model: aRBModel combine: anInterval from: aSelector in: aClass
	^ self new 
		model: aRBModel;
		combine: anInterval from: aSelector in: aClass;
		yourself! !

!RBCreateCascadeRefactoring methodsFor: 'as yet unclassified' stamp: 'rms 4/9/2015 21:05'!
addStatementNode: aNode
	aNode isMessage
		ifTrue: [ ^ statementNodes add: aNode ].
	aNode isCascade
		ifTrue: [ ^ statementNodes addAll: aNode messages ].
	self refactoringError: aNode formattedCode , ' is not a valid message'! !

!RBCreateCascadeRefactoring methodsFor: 'as yet unclassified' stamp: 'rms 4/9/2015 21:05'!
combine: anInterval from: aSelector in: aClass
	class := self classObjectFor: aClass.
	selector := aSelector.
	selectedInterval := anInterval! !

!RBCreateCascadeRefactoring methodsFor: 'as yet unclassified' stamp: 'rms 4/9/2015 21:05'!
combineMessages
	"This combines the messages and adds the assignements of the last statement to the cascade. This is not necessary if there is a return, because the refactoring engine automatically compensates for that."

	| expression |
	transformedNode := RBCascadeNode messages: (statementNodes
		collect: [ :each | each copy ]).
	expression := statementNodes last parent.
	[ expression isAssignment ] whileTrue: [
		transformedNode := RBAssignmentNode
			variable: expression variable
			value: transformedNode.
		expression := expression parent ]! !

!RBCreateCascadeRefactoring methodsFor: 'as yet unclassified' stamp: 'rms 4/9/2015 21:05'!
compileCode
	class compileTree: (RBParseTreeRewriter
		replaceStatements: sequenceNode formattedCode
		with: transformedNode formattedCode
		in: self parseTree
		onInterval: selectedInterval)! !

!RBCreateCascadeRefactoring methodsFor: 'as yet unclassified' stamp: 'rms 4/9/2015 21:05'!
findReceiverNode
	"Find the sequence to be combined."

	| receiverNodes |
	receiverNodes := statementNodes 
		collect: [ :each | each receiver ].
	receiverNodes asSet size = 1
		ifFalse: [ self refactoringError: 'All statements must have the same receiver' ].
	(receiverNodes first isLiteralNode or: [ receiverNodes first isVariable ])
		ifFalse: [ self refactoringWarning: 'The receiver is an expression. Proceed with caution' ]! !

!RBCreateCascadeRefactoring methodsFor: 'as yet unclassified' stamp: 'rms 4/9/2015 21:05'!
findSequenceNode
	"Find the sequence to be combined."

	sequenceNode := RBParser
		parseExpression: self selectedSource
		onError: [ :msg :pos | self refactoringError: 'Invalid source to rewrite' ].
	(sequenceNode isSequence and: [ sequenceNode statements size > 1 ])
		ifFalse: [ self refactoringError: 'You must select two or more statements' ]! !

!RBCreateCascadeRefactoring methodsFor: 'as yet unclassified' stamp: 'rms 4/9/2015 21:06'!
findStatementNodes
	"Find the sequence to be combined."

	statementNodes := OrderedCollection new.
	sequenceNode statements do: [ :each |
		(sequenceNode isLast: each)
			ifFalse: [ self addStatementNode: each ]
			ifTrue: [
				| current |
				current := each.
				[ current isReturn or: [ current isAssignment ] ]
					whileTrue: [ current := current value ].
				self addStatementNode: current ] ]! !

!RBCreateCascadeRefactoring methodsFor: 'as yet unclassified' stamp: 'rms 4/9/2015 21:06'!
parseTree
	parseTree isNil ifTrue: [
		parseTree := class parseTreeFor: selector.
		parseTree isNil
			ifTrue: [ self refactoringError: 'Could not parse sources' ] ].
	^ parseTree! !

!RBCreateCascadeRefactoring methodsFor: 'as yet unclassified' stamp: 'rms 4/9/2015 21:06'!
preconditions
	^ (RBCondition definesSelector: selector in: class) & (RBCondition withBlock: [ 
		self findSequenceNode; findStatementNodes; findReceiverNode.
		true ])! !

!RBCreateCascadeRefactoring methodsFor: 'as yet unclassified' stamp: 'rms 4/9/2015 21:06'!
selectedSource
	^  self parseTree source copyFrom: selectedInterval first to: selectedInterval last! !

!RBCreateCascadeRefactoring methodsFor: 'as yet unclassified' stamp: 'rms 4/9/2015 21:06'!
transform
	self combineMessages.
	self compileCode! !

RBMethodRefactoring subclass: #RBSplitCascadeRefactoring
	instanceVariableNames: 'selector selectedInterval parseTree cascadeNode beforeNodes afterNodes ancestorNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RefactoringTools'!

!RBSplitCascadeRefactoring class methodsFor: 'as yet unclassified' stamp: 'rms 4/12/2015 18:12'!
model: aRBModel split: anInterval from: aSelector in: aClass
	^ self new 
		model: aRBModel;
		split: anInterval from: aSelector in: aClass;
		yourself! !

!RBSplitCascadeRefactoring class methodsFor: 'as yet unclassified' stamp: 'rms 4/9/2015 21:02'!
split: anInterval from: aSelector in: aClass
	^ self new 
		split: anInterval from: aSelector in: aClass;
		yourself! !

!RBSplitCascadeRefactoring methodsFor: 'as yet unclassified' stamp: 'rms 4/9/2015 20:58'!
extractReceiver
	| name |
	(cascadeNode receiver isLiteralNode or: [ cascadeNode receiver isVariable ])
		ifTrue: [ ^ self ].
	name := self 
		safeVariableNameFor: class 
		temporaries: self parseTree allDefinedVariables 
		basedOn: 'receiver'.
	ancestorNode parent
		addTemporaryNamed: name;
		addNode: (RBAssignmentNode 
			variable: (RBVariableNode named: name)
			value: cascadeNode receiver)
		before: ancestorNode.
	cascadeNode messages
		do: [ :each | each receiver: (RBVariableNode named: name) ]
		! !

!RBSplitCascadeRefactoring methodsFor: 'as yet unclassified' stamp: 'rms 4/9/2015 20:58'!
findAncestorNode
	"The ancestor node is the node that is contained within the sequence. In most cases this is the cascade itself, but it also can be an assignment or a return node."

	ancestorNode := cascadeNode.
	[ ancestorNode parent isSequence not and: [ ancestorNode parent isAssignment ] ]
		whileTrue: [ ancestorNode := ancestorNode parent ].
	[ ancestorNode parent isSequence not and: [ ancestorNode parent isReturn ] ]
		whileTrue: [ ancestorNode := ancestorNode parent ].
	ancestorNode parent isSequence
		ifFalse: [ self refactoringError: 'To split this cascade, you must extract it to a temporary first' ]! !

!RBSplitCascadeRefactoring methodsFor: 'as yet unclassified' stamp: 'rms 4/9/2015 20:58'!
findCascadeNode
	"Find the cascade to be split."

	cascadeNode := self parseTree bestNodeFor: selectedInterval.
	[ cascadeNode isNil or: [ cascadeNode isCascade ] ]
		whileFalse: [ cascadeNode := cascadeNode parent ].
	cascadeNode isNil
		ifTrue: [ self refactoringError: 'The selection doesn''t appear to be within a cascade' ]! !

!RBSplitCascadeRefactoring methodsFor: 'as yet unclassified' stamp: 'rms 4/9/2015 20:59'!
findMessageNodes
	"Find the nodes that form the first part of the cascade and the second part of the cascade."

	beforeNodes := cascadeNode messages
		select: [ :each | each stop <= selectedInterval first ].
	afterNodes := cascadeNode messages
		select: [ :each | selectedInterval last <= each selectorParts first start ].
	(beforeNodes isEmpty or: [ afterNodes isEmpty ])
		ifTrue: [ self refactoringError: 'Splitting a cascade into the whole cascade and an empty one is pointless' ].
	(beforeNodes size + afterNodes size = cascadeNode messages size)
		ifFalse: [ self refactoringError: 'To set the split boundary place the cursor inbetween two cascaded messages' ]! !

!RBSplitCascadeRefactoring methodsFor: 'as yet unclassified' stamp: 'rms 4/9/2015 20:59'!
parseTree
	parseTree isNil ifTrue: [
		parseTree := class parseTreeFor: selector.
		parseTree isNil
			ifTrue: [ self refactoringError: 'Could not parse sources' ] ].
	^ parseTree! !

!RBSplitCascadeRefactoring methodsFor: 'as yet unclassified' stamp: 'rms 4/9/2015 20:59'!
preconditions
	^ (RBCondition definesSelector: selector in: class) & (RBCondition withBlock: [ 
		self findCascadeNode; findAncestorNode; findMessageNodes. 
		true ])! !

!RBSplitCascadeRefactoring methodsFor: 'as yet unclassified' stamp: 'rms 4/9/2015 20:59'!
split: anInterval from: aSelector in: aClass
	class := self classObjectFor: aClass.
	selector := aSelector.
	selectedInterval := anInterval! !

!RBSplitCascadeRefactoring methodsFor: 'as yet unclassified' stamp: 'rms 4/9/2015 20:59'!
splitCascade
	ancestorNode parent
		addNode: (beforeNodes size > 1
			ifTrue: [ RBCascadeNode messages: beforeNodes ]
			ifFalse: [ beforeNodes first ])
		before: ancestorNode.
	afterNodes size > 1
		ifTrue: [ cascadeNode messages: afterNodes ]
		ifFalse: [ cascadeNode replaceWith: afterNodes first ].
	class compileTree: ancestorNode methodNode! !

!RBSplitCascadeRefactoring methodsFor: 'as yet unclassified' stamp: 'rms 4/9/2015 20:59'!
transform
	self extractReceiver.
	self splitCascade! !

!MenuMorph methodsFor: '*RefactoringTools-menu building' stamp: 'eem 1/4/2018 16:38'!
addRefactorings: refactorings withName: name for: aTarget
	| subMenu |
	subMenu := MenuMorph new.
	refactorings keysAndValuesDo:
		[:nameAndSelector :description |
		 subMenu add: nameAndSelector key
				    target: aTarget
				    selector: #performRefactoring:
				    argument:  nameAndSelector value.
		 subMenu balloonTextForLastItem: description].
	self add: name subMenu: subMenu! !

Object subclass: #MultipleChoiceRequest
	instanceVariableNames: 'labels values lines selection title'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RefactoringTools'!

!MultipleChoiceRequest class methodsFor: 'as yet unclassified' stamp: 'rms 3/27/2015 19:13'!
on: anArray title: aTitle

	^self new 
		setTitle: aTitle
		labels: anArray
		values: anArray
		lines: aTitle;
		yourself
				! !

!MultipleChoiceRequest class methodsFor: 'as yet unclassified' stamp: 'rms 4/8/2015 22:52'!
on: anArray values: values title: aTitle

	^self new 
		setTitle: aTitle
		labels: anArray
		values: values
		lines: aTitle;
		yourself
				! !

!MultipleChoiceRequest methodsFor: 'as yet unclassified' stamp: 'rms 3/27/2015 18:46'!
label: anObject
	^ ((selection includes: anObject) ifTrue: [ '<yes>' ] ifFalse: [ '<no>' ]) , 
	  (labels at: (values indexOf: anObject ifAbsent: [ ^ nil ]))! !

!MultipleChoiceRequest methodsFor: 'as yet unclassified' stamp: 'rms 3/27/2015 18:46'!
selection
	^ selection! !

!MultipleChoiceRequest methodsFor: 'as yet unclassified' stamp: 'rms 3/27/2015 18:41'!
setTitle: aString labels: labelArray values: valueArray lines: lineArray 
	title := aString.
	labels := labelArray.
	values := valueArray.
	lines := lineArray.
	selection := IdentitySet withAll: valueArray! !

!MultipleChoiceRequest methodsFor: 'as yet unclassified' stamp: 'rms 3/27/2015 19:02'!
title
	^title! !

!MultipleChoiceRequest methodsFor: 'as yet unclassified' stamp: 'rms 3/27/2015 19:01'!
title: aString
	title := aString! !

!MultipleChoiceRequest methodsFor: 'as yet unclassified' stamp: 'rms 3/27/2015 18:41'!
toggle: anObject
	(selection includes: anObject)
		ifTrue: [ selection remove: anObject ]
		ifFalse: [ selection add: anObject ]! !

!MultipleChoiceRequest methodsFor: 'as yet unclassified' stamp: 'rms 3/27/2015 18:41'!
toggleMorphic: anObject
	"This seems to be somehow required to properly refersh the checkbox."

	self toggle: anObject.
	World restoreDisplay! !

!MultipleChoiceRequest methodsFor: 'as yet unclassified' stamp: 'rms 3/27/2015 19:02'!
values
	^values! !

!MultipleChoiceRequest methodsFor: 'as yet unclassified' stamp: 'rms 3/27/2015 19:01'!
values: anArray
	values := anArray! !

!MessageSet methodsFor: '*RefactoringTools' stamp: 'eem 1/4/2018 16:57'!
browserModel
	^(RBNamespace onEnvironment: 
		(RBBrowserEnvironment new 
			forClasses: {self selectedClassOrMetaClass}))! !

!MessageSet methodsFor: '*RefactoringTools-source-refactoring' stamp: 'eem 1/4/2018 16:28'!
sourceRefactoringsAreApplicable
	^self contents notNil and: [self selectedMessageName notNil]! !

!Browser methodsFor: '*RefactoringTools-class-variable' stamp: 'rms 4/13/2015 11:44'!
abstractClassVarRefactoring
	^(RBAbstractClassVariableRefactoring
		model: self browserModel
		variable: self selectClassVariable
		class: self selectedClass)! !

!Browser methodsFor: '*RefactoringTools-inst-variable' stamp: 'eem 3/13/2018 15:45'!
abstractInstVarRefactoring
	^RBAbstractInstanceVariableRefactoring
		model: self browserModel
		variable: self selectInstanceOrClassInstanceVariable
		class: self selectedClassOrMetaClass! !

!Browser methodsFor: '*RefactoringTools-class-variable' stamp: 'eem 11/2/2017 15:31'!
accessorClassVarRefactoring
	^RBCreateAccessorsForVariableRefactoring
		model: self browserModel
		variable: self selectClassVariable
		class: self selectedClass
		classVariable: true! !

!Browser methodsFor: '*RefactoringTools-inst-variable' stamp: 'eem 3/13/2018 15:45'!
accessorInstVarRefactoring
	^RBCreateAccessorsForVariableRefactoring
		model: self browserModel
		variable: self selectInstanceOrClassInstanceVariable
		class: self selectedClassOrMetaClass
		classVariable: false! !

!Browser methodsFor: '*RefactoringTools-class-variable' stamp: 'rms 4/13/2015 11:45'!
addClassVarRefactoring
	^RBAddClassVariableRefactoring
		model: self browserModel
		variable: (self request: 'Enter variable name:' initialAnswer: '')
		class: self selectedClass! !

!Browser methodsFor: '*RefactoringTools-inst-variable' stamp: 'eem 3/13/2018 15:28'!
addInstVarRefactoring
	^RBAddInstanceVariableRefactoring
		model: self browserModel
		variable: (self request: 'Enter variable name: ' initialAnswer: '')
		class: self selectedClassOrMetaClass
		! !

!Browser methodsFor: '*RefactoringTools-message-refactoring' stamp: 'eem 3/13/2018 15:28'!
addParameterMethodRefactoring
| initializer newSelector initialAnswer |
	initialAnswer := self selectedMessageName numArgs = 0 
		ifTrue: [ self selectedMessageName , ':' ]
		ifFalse: [ self selectedMessageName ].
	newSelector := self 
		request: 'Enter new selector:'
		initialAnswer: initialAnswer.
	newSelector isEmpty ifTrue: [ ^ nil ].
	initializer := self 
		request: 'Enter default value for parameter:'
		initialAnswer: 'nil'.
	initializer isEmpty ifTrue: [ ^ nil ].
	^RBAddParameterRefactoring
		addParameterToMethod: self selectedMessageName
		in: self selectedClassOrMetaClass
		newSelector: newSelector asSymbol
		initializer: initializer! !

!Browser methodsFor: '*RefactoringTools' stamp: 'rms 4/6/2015 17:33'!
browserModel
	^(RBNamespace onEnvironment: 
		(RBBrowserEnvironment new 
			forClasses: (self defaultClassList 
				collect: [:className | 
						 self selectedEnvironment at: className])))! !

!Browser methodsFor: '*RefactoringTools' stamp: 'rms 4/14/2015 17:21'!
cancelRefactoring
	^ RBRefactoringError signal: 'Canceled Refactoring!!'! !

!Browser methodsFor: '*RefactoringTools' stamp: 'eem 3/13/2018 15:29'!
chooseFieldAccessors
	| labels accessors matcher selectors |
	labels := OrderedCollection new.
	accessors := OrderedCollection new.
	matcher := RBParseTreeSearcher new.
	matcher 
		matches: '^ `var' do: [ :node :answer | answer add: node value name; yourself ];
		matches: '^ `var `@method: `@args' do: [ :node :answer | answer add: node value receiver name; yourself ].
	self selectedClassOrMetaClass withAllSuperclassesDo: [ :class |
		class allInstVarNames do: [ :variable |
			selectors := (((class whichSelectorsAccess: variable)
				select: [ :each | each numArgs = 0 ])
				reject: [ :each | accessors includes: each ])
				select: [ :each |
					| tree |
					tree := class parseTreeFor: each.
					tree notNil and: [ (matcher executeTree: tree initialAnswer: Set new) includes: variable ] ].
			selectors do: [ :selector |
				accessors add: selector.
				labels add: selector printString , ' (' , variable , ')' ] ] ].
	^ self handleMultipleChoiceRequest: 
		(MultipleChoiceRequest 
			on: labels 
			values: accessors
			title: 'Select the fields to compare:') ! !

!Browser methodsFor: '*RefactoringTools' stamp: 'rms 4/10/2015 15:12'!
chooseFrom: anArray title: aTitle
	^UIManager default chooseFrom: anArray values: anArray title: aTitle! !

!Browser methodsFor: '*RefactoringTools' stamp: 'rms 3/27/2015 19:00'!
chooseMultipleFrom: anArray title: aTitle
	| selected |

	selected := self handleMultipleChoiceRequest: 
		(MultipleChoiceRequest on: anArray title: aTitle).

	^selected ifNil: #().! !

!Browser methodsFor: '*RefactoringTools-class-refactoring' stamp: 'eem 1/4/2018 16:39'!
classRefactoringMenu: aMenu
	<classListMenu>
	<messageListMenu>
	<codePaneMenu>
	<menuPriority:  400>
	self classRefactorings ifNotEmpty:
		[aMenu addRefactorings: self classRefactorings withName: 'refactor class' for: self].
	^aMenu! !

!Browser methodsFor: '*RefactoringTools-class-refactoring' stamp: 'rms 4/10/2015 00:01'!
classRefactorings
	^{'create subclass' 
			-> #createSubclassRefactoring 
			-> 'This refactoring allows you to insert a new class into an existing hierarchy.'.
	    'accessors' 
			-> #createAccessorClassRefactoring 
			->  'Creates getter and setter methods for all class variables.'.
	    'create superclass' 
			-> #createSuperclassRefactoring 
			-> 'This refactoring allows you to insert a new class into an existing hierarchy.'.
	    'generate #= and #hash'
			-> #generateEqualHashRefactoring 
			-> 'This refactoring adds comparator method for the selected accessors.' .
	    'generate #printOn:' 
			-> #generatePrintStringRefactoring 
			-> 'This refactoring adds a default print string implementation' .
	    'realize' 
			-> #realizeClassRefactoring 
			-> 'This refactoring makes an abstract class concrete by installing some stub methods.' .
	    'rename' 
			-> #renameClassRefactoring
			-> 'This refactoring renames a class and also renames every reference to the class in the code. Even symbols with the same name as the class will also be renamed.' .
	    'split' 
			-> #splitClassRefactoring
			-> 'This refactoring splits a class into two classes.'} as: Dictionary ! !

!Browser methodsFor: '*RefactoringTools-class-refactoring' stamp: 'rms 4/6/2015 12:33'!
classRefactoringsAreApplicable
"Determine if the class refactorings can be applied to the currently selected code"
	^self classList notEmpty and: self classRefactorings notEmpty! !

!Browser methodsFor: '*RefactoringTools-class-variable' stamp: 'eem 1/4/2018 16:39'!
classVarRefactoringMenu: aMenu
	<messageListMenu>
	<classListMenu>
	<codePaneMenu>
	<menuPriority:  400>
	self classVarRefactorings ifNotEmpty:
		[aMenu addRefactorings: self classVarRefactorings withName: 'refactor class var' for: self].
	^aMenu
	! !

!Browser methodsFor: '*RefactoringTools-class-variable' stamp: 'rms 4/13/2015 14:09'!
classVarRefactorings
	^{'abstract' 
			-> #abstractClassVarRefactoring 
			-> 'Performs the create accessors refactoring and then converts all direct variable to use the accessor methods. ' .
	    'accessors'
			-> #accessorClassVarRefactoring
			-> 'Creates getter and setter methods for a variable.' .
	    'add' 
			-> #addClassVarRefactoring
			-> 'Add a variable to the class' .
	    'pull up'
			-> #pullUpClassVarRefactoring
			-> 'Move a variable definition from the currently selected class into the superclass.' .
	    "'push down' CURRENTLY NOT SUPPORTED IN SQUEAK
			-> #pushDownClassVarRefactoring
			-> 'Moves a variable definition from the currently selected class to only those subcasses that use the variable.' ."
	    'remove'
			-> #removeClassVarRefactoring
			-> 'Removes a variable only if it is not referenced.' .
	    'rename'
			-> #renameClassVarRefactoring
			-> 'Renames a variable and all references to the variable.' } as: Dictionary! !

!Browser methodsFor: '*RefactoringTools-class-refactoring' stamp: 'rms 4/12/2015 18:42'!
createAccessorClassRefactoring 
	"Creates getter and setter methods for all variables."
	| changes |
	changes := OrderedCollection new.
	self selectedClass allInstVarNames do: [:instVar |
		changes add: (RBCreateAccessorsForVariableRefactoring
			model: self browserModel
			variable: instVar
			class: self selectedClass
			classVariable: false)].
	self selectedClass allClassVarNames do: [:classVar |
		changes add: (RBCreateAccessorsForVariableRefactoring
			model: self browserModel
			variable: classVar
			class: self selectedClass
			classVariable: true)].
	^changes! !

!Browser methodsFor: '*RefactoringTools-class-refactoring' stamp: 'rms 4/14/2015 17:26'!
createSubclassRefactoring
	| class subclassName |
	class := self selectedClass.
	subclassName := self request: 'Enter new subclass name:' initialAnswer: ''.
	^ RBAddClassRefactoring
		model: self browserModel
		addClass: subclassName
		superclass: class
		subclasses:
			((UIManager default chooseMultipleFrom: class subclasses
								 values: class subclasses
								 title: 'Select subclasses of ' , subclassName , ':')
				ifNil: [ self cancelRefactoring ])
		category: class category! !

!Browser methodsFor: '*RefactoringTools-class-refactoring' stamp: 'rms 4/14/2015 17:27'!
createSuperclassRefactoring
	| class superclassName |
	class := self selectedClass.
	superclassName := self request: 'Enter new superclass name:' initialAnswer: ''.
	^ RBChildrenToSiblingsRefactoring
		model: self browserModel
		name: superclassName
		class: class
		subclasses: ((UIManager default
			chooseMultipleFrom: class subclasses
			values: class subclasses
			title: 'Select subclasses of ' , superclassName , ':')
			ifNil: [self cancelRefactoring])! !

!Browser methodsFor: '*RefactoringTools-class-refactoring' stamp: 'rms 4/12/2015 18:43'!
generateEqualHashRefactoring
	^RBGenerateEqualHashRefactoring
		model: self browserModel
		className: self selectedClassName
		selectors: self chooseFieldAccessors! !

!Browser methodsFor: '*RefactoringTools-class-refactoring' stamp: 'rms 4/12/2015 18:44'!
generatePrintStringRefactoring
	^RBGeneratePrintStringRefactoring
		model: self browserModel
		className: self selectedClassName
		variables: self chooseFieldAccessors! !

!Browser methodsFor: '*RefactoringTools' stamp: 'rms 4/14/2015 15:23'!
handleMultipleChoiceRequest: aRequest
	| menu |
	aRequest values isEmpty
		ifTrue: [ ^ aRequest values ].
	menu := MenuMorph new.
	menu stayUp: true.
	aRequest title isEmptyOrNil
		ifFalse: [ menu addTitle: aRequest title ].
	aRequest values
		do: [ :value | 
			menu
				addUpdating: #label:
				target: aRequest
				selector: #toggleMorphic:
				argumentList: (Array with: value) ].
	menu addLine.
	menu add: 'ok' target: menu selector: #delete.
	menu invokeModal.
	^ aRequest selection asArray! !

!Browser methodsFor: '*RefactoringTools-message-refactoring' stamp: 'eem 3/13/2018 15:30'!
inlineParameterMethodRefactoring
	^RBInlineParameterRefactoring
		inlineParameter: (self chooseFrom: self selectedMessageArguments title: 'Select parameter to be inlined:')
		in: self selectedClassOrMetaClass
		selector: self selectedMessageName! !

!Browser methodsFor: '*RefactoringTools-message-refactoring' stamp: 'eem 3/13/2018 15:30'!
inlineSelfSendsMethodRefactoring
	^RBInlineAllSendersRefactoring
		sendersOf: self selectedMessageName
		in: self selectedClassOrMetaClass! !

!Browser methodsFor: '*RefactoringTools-inst-variable' stamp: 'eem 1/4/2018 16:38'!
instVarRefactoringMenu: aMenu
	<classListMenu>
	<messageListMenu>
	<codePaneMenu>
	<menuPriority:  400>
	self instVarRefactorings ifNotEmpty:
		[aMenu addRefactorings: self instVarRefactorings withName: 'refactor instance var' for: self].
	^aMenu! !

!Browser methodsFor: '*RefactoringTools-inst-variable' stamp: 'eem 3/13/2018 15:39'!
instVarRefactorings
	^{'abstract' 
			-> #abstractInstVarRefactoring 
			-> 'Performs the create accessors refactoring and then converts all direct variable accesses to use the accessor methods.' .
	    'accessors'
			-> #accessorInstVarRefactoring
			-> 'Creates getter and setter methods for a variable.' .
	    'add' 
			-> #addInstVarRefactoring
			-> 'Add a variable to the class' .
	    'protect'
			-> #protectInstVarRefactoring
			-> 'Converts all variable accessor sends to direct variable references. If the accessor is no longer used then it will be removed!!' .
	    'pull up'
			-> #pullUpInstVarRefactoring
			-> 'Move a variable definition from the currently selected class into the superclass.' .
	    'push down'
			-> #pushDownInstVarRefactoring
			-> 'Moves a variable definition from the currently selected class to only those subcasses that use the variable.' .
	    'remove'
			-> #removeInstVarRefactoring
			-> 'Removes a variable only if it is not referenced.' .
	    'rename'
			-> #renameInstVarRefactoring
			-> 'Renames a variable and all references to the variable.' } as: Dictionary! !

!Browser methodsFor: '*RefactoringTools-message-refactoring' stamp: 'eem 1/4/2018 16:38'!
messageRefactoringMenu: aMenu
	<messageListMenu>
	<codePaneMenu>
	<menuPriority:  400>
	self messageRefactorings ifNotEmpty:
		[aMenu addRefactorings: self messageRefactorings withName: 'refactor method' for: self].
	^aMenu! !

!Browser methodsFor: '*RefactoringTools-message-refactoring' stamp: 'rms 4/9/2015 21:15'!
messageRefactorings
	^{'add parameter' 
			-> #addParameterMethodRefactoring 
			-> 'Adds a default parameter to all implementors of the method.' . 
	   'inline parameter' 
			-> #inlineParameterMethodRefactoring
			-> 'Remove a parameter from the method, and adds an assignment at the beginning of the method. This can only be performed if all senders of the method have the same value for the parameter.' .
	   'linline sends to self' 
			-> #inlineSelfSendsMethodRefactoring 
			-> 'Inlines all senders within the class of the method. If there are no more senders after all inlines have been performed, then it will also remove the method.' .
         'move method' 
			-> #moveMethodRefactoring 
			-> 'Moves a method to another object (defined by an argument of instance variable).' .
	   'push down' 
			-> #pushDownMethodRefactoring 
			-> 'Pushes a method down to all subclasses that do not implement the method. This can only be allowed if the class is abstract.' .
	   'push up' 
			-> #pushUpMethodRefactoring 
			-> 'Pushes a method up into the superclass. If the superclass is abstract and already defines the method, then the superclass'' method will be copied down into the other subclasses (assuming they do not already define the method). ' .
	   'remove parameter' 
			-> #removeParameterMethodRefactoring 
			-> 'Removes an unused parameter from all implementors of the method, and removes it from the message sends.' .
	   'rename' 
			-> #renameMethodRefactoring 
			-> 'Renames all implementors of a method, all senders, and all symbols references. In addition to strict renaming, it also allows you to rearrange the parameters.' .
	  } as: Dictionary ! !

!Browser methodsFor: '*RefactoringTools-message-refactoring' stamp: 'eem 3/13/2018 15:45'!
moveMethodRefactoring
	^RBMoveMethodRefactoring
		selector: self selectedMessageName
		class: self selectedClassOrMetaClass
		variable: self selectInstanceOrClassInstanceVariable! !

!Browser methodsFor: '*RefactoringTools-inst-variable' stamp: 'eem 3/13/2018 15:45'!
protectInstVarRefactoring
	^RBProtectInstanceVariableRefactoring
		model: self browserModel
		variable: self selectInstanceOrClassInstanceVariable
		class: self selectedClassOrMetaClass! !

!Browser methodsFor: '*RefactoringTools-class-variable' stamp: 'eem 11/2/2017 15:31'!
pullUpClassVarRefactoring
	^ RBPullUpClassVariableRefactoring
		model: self browserModel
		variable: self selectClassVariable
		class: self selectedClass superclass! !

!Browser methodsFor: '*RefactoringTools-inst-variable' stamp: 'eem 3/13/2018 15:45'!
pullUpInstVarRefactoring
	^RBPullUpInstanceVariableRefactoring
		model: self browserModel
		variable: self selectInstanceOrClassInstanceVariable
		class: self selectedClassOrMetaClass superclass! !

!Browser methodsFor: '*RefactoringTools-class-variable' stamp: 'eem 11/2/2017 15:31'!
pushDownClassVarRefactoring
	^RBPushDownClassVariableRefactoring
		model: self browserModel
		variable: self selectClassVariable
		class: self selectedClass! !

!Browser methodsFor: '*RefactoringTools-inst-variable' stamp: 'eem 3/13/2018 15:45'!
pushDownInstVarRefactoring
	^ RBPushDownInstanceVariableRefactoring
		model: self browserModel
		variable: self selectInstanceOrClassInstanceVariable
		class: self selectedClassOrMetaClass! !

!Browser methodsFor: '*RefactoringTools-message-refactoring' stamp: 'eem 3/13/2018 15:36'!
pushDownMethodRefactoring
	^RBPushDownMethodRefactoring
		pushDown: (Array with: self selectedMessageName)
		from: self selectedClassOrMetaClass! !

!Browser methodsFor: '*RefactoringTools-message-refactoring' stamp: 'eem 3/13/2018 15:36'!
pushUpMethodRefactoring
	^RBPullUpMethodRefactoring
		pullUp: (Array with: self selectedMessageName)
		from: self selectedClassOrMetaClass! !

!Browser methodsFor: '*RefactoringTools-class-refactoring' stamp: 'rms 4/12/2015 18:45'!
realizeClassRefactoring
	^RBRealizeClassRefactoring
		model: self browserModel
		className: self selectedClassName! !

!Browser methodsFor: '*RefactoringTools-class-variable' stamp: 'eem 11/2/2017 15:31'!
removeClassVarRefactoring
	^RBRemoveClassVariableRefactoring
		model: self browserModel
		variable: self selectClassVariable
		class: self selectedClass! !

!Browser methodsFor: '*RefactoringTools-inst-variable' stamp: 'eem 3/13/2018 15:45'!
removeInstVarRefactoring
	^RBRemoveInstanceVariableRefactoring
		model: self browserModel
		variable: self selectInstanceOrClassInstanceVariable
		class: self selectedClassOrMetaClass! !

!Browser methodsFor: '*RefactoringTools-message-refactoring' stamp: 'eem 3/13/2018 15:35'!
removeParameterMethodRefactoring
	^RBRemoveParameterRefactoring
		removeParameter: (self chooseFrom: self arguments)
		in: self selectedClassOrMetaClass
		selector: self selectedMessageName! !

!Browser methodsFor: '*RefactoringTools-class-refactoring' stamp: 'rms 4/12/2015 19:51'!
renameClassRefactoring
	^(RBRenameClassRefactoring
		model: self browserModel
		rename: self selectedClass
		to: (self request: 'Enter new name for class:' initialAnswer: self selectedClassName)) ! !

!Browser methodsFor: '*RefactoringTools-class-variable' stamp: 'mt 9/25/2017 10:34'!
renameClassVarRefactoring
		
	| variable |
	variable := self selectClassVariable.
	^RBRenameClassVariableRefactoring
		model: self browserModel
		rename: variable
		to: (self request: 'Enter new name: ' initialAnswer: variable)
		in: self selectedClass! !

!Browser methodsFor: '*RefactoringTools-inst-variable' stamp: 'eem 3/13/2018 15:45'!
renameInstVarRefactoring
	| variable |
	variable := self selectInstanceOrClassInstanceVariable.
	^RBRenameInstanceVariableRefactoring
		model: self browserModel
		rename: variable
		to: (self request: 'Enter new name: ' initialAnswer: variable)
		in: self selectedClassOrMetaClass! !

!Browser methodsFor: '*RefactoringTools-message-refactoring' stamp: 'eem 3/13/2018 15:43'!
renameMethodRefactoring
	| method class oldArguments oldMethodName newMethodName argumentPermutation|
	method := self selectedMessageName.
	class := self selectedClassOrMetaClass.
	oldArguments := (RBParser parseMethod: (class methodHeaderFor: method)) argumentNames.
	oldMethodName := RBMethodName 
		selector: method
		arguments: oldArguments.
	(newMethodName := self requestMethodNameFor: oldMethodName) ifNil: [ ^ nil ].
	argumentPermutation := newMethodName arguments collect: [ :each | oldArguments indexOf: each ].
	^RBRenameMethodRefactoring
		renameMethod: method
		in: class
		to: newMethodName selector
		permutation: argumentPermutation! !

!Browser methodsFor: '*RefactoringTools-class-variable' stamp: 'eem 11/2/2017 15:30'!
selectClassVariable
	| classVars |
	classVars := self selectedClass classVarNames.
	^classVars 
		ifEmpty: [RBRefactoringError signal: 'There are no class-variables defined in this class!!'. nil]
		ifNotEmpty: [(self chooseFrom: classVars title: 'Select class variable:') asString]! !

!Browser methodsFor: '*RefactoringTools-inst-variable' stamp: 'eem 3/13/2018 15:45'!
selectInstanceOrClassInstanceVariable
	| instVars |
	instVars := self selectedClassOrMetaClass instVarNames.
	instVars 
		ifEmpty: [RBRefactoringError signal: 'No instance variables available!!']
		ifNotEmpty: [^self chooseFrom: instVars title: 'Select instance variable:'].! !

!Browser methodsFor: '*RefactoringTools-inst-variable' stamp: 'rms 4/13/2015 13:32'!
selectInstanceVariable
	| instVars |
	instVars := self selectedClass instVarNames.
	instVars 
		ifEmpty: [RBRefactoringError signal: 'No instance variables available!!']
		ifNotEmpty: [^self chooseFrom: instVars title: 'Select instance variable:'].! !

!Browser methodsFor: '*RefactoringTools' stamp: 'eem 3/13/2018 16:03'!
selectedMessageArguments
	^ (RBMethod 
		for: ((self metaClassIndicated
				ifTrue: [RBMetaclass]
				ifFalse: [RBClass])
					existingNamed: self selectedClassName)
		source: self selectedMessage
		selector: self selectedMessageName) 
			parseTree arguments collect: [:arg | arg name]! !

!Browser methodsFor: '*RefactoringTools-source-refactoring' stamp: 'rms 4/6/2015 12:30'!
sourceRefactoringsAreApplicable
	^self contents notNil and: self selectedMessageName notNil! !

!Browser methodsFor: '*RefactoringTools-class-refactoring' stamp: 'rms 4/14/2015 17:27'!
splitClassRefactoring
	^ RBSplitClassRefactoring
		model: self browserModel
		class: self selectedClass
		instanceVariables: ((UIManager default 
			chooseMultipleFrom: self selectedClass instVarNames
			values: self selectedClass instVarNames
			title: 'Select variables to extract:') ifNil: [self cancelRefactoring])
		newClassName: (self request: 'Enter new class name:' initialAnswer: '')
		referenceVariableName: (self request: 'Enter new variable name where requests will be forwarded:' initialAnswer: '')! !
